#include "term.h"
#include "io.h"
#include "mainloop.h"
#include "8080.h"
#include "files.h"

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>

int main(int argc, char **argv) {
	int start = -1;
	int bdos = 0;
	float speed = 0;
	char term = 0;
	int c;
	int i;
	int quit_signal;

	init_filenames();

	while((c = getopt(argc, argv, "a:b:c:d:e:f:l:p:r:o:s:txyz")) != -1) {
		switch(c) {
			case 'a':
			case 'b':
			case 'c':
			case 'd':
				memcpy(fd_name[c - 'a'], optarg,
					FNLENGTH * sizeof(char));
				break;
			case 'e':
			case 'f':
				memcpy(hd_name[c - 'e'], optarg,
					FNLENGTH * sizeof(char));
				break;
			case 'r':
				memcpy(rdr_name, optarg,
					FNLENGTH * sizeof(char));
				break;
			case 'l':
				memcpy(lst_name, optarg,
					FNLENGTH * sizeof(char));
				break;
			case 'p':
				memcpy(pun_name, optarg,
					FNLENGTH * sizeof(char));
				break;
			case 's':
				if(!sscanf(optarg, "%f", &speed)) {
					fprintf(stderr,
						"No valid speed: %s\n",
						optarg);
					exit(1);
				}
				break;
			case 'o':
				if(!sscanf(optarg, "%x", &start)) {
					fprintf(stderr,
						"No valid address: %s\n",
						optarg);
					exit(1);
				}
				break;
			case 't':
				setaltair();
				break;
			case 'x':
				bdos = 1;
				break;
			case 'y':
				term = 1;
				break;
			case 'z':
				swap_ru_bs = 1;
				break;
			case '?':
				if(optopt == 'a' || optopt == 'b'
					|| optopt == 'c'
					|| optopt == 'd'
					|| optopt == 's') {
					fprintf(stderr,
						"Option -%c requires an argument.\n", optopt);
				} else if(isprint (optopt)) {
					fprintf(stderr, "Unknown option `-%c'.\n", optopt);
				} else {
					fprintf(stderr,
						"Unknown option character `\\x%x'.\n", optopt);
				}
				exit(1);
			default:
				abort();
		}
	}

	if(optind < argc) {
		memcpy(rom_name, argv[optind], FNLENGTH * sizeof(char));
	}

	if(start == -1) {
		start = bdos ? 0x100 : 0;
	}
	for(i = 0; i < 4; i++) {
		if(fd_name[i][0]) {
			readdisk(fd_name[i], i);
		}
	}

	for(i = 0; i < 2; i++) {
		if(hd_name[i][0]) {
			readhd(hd_name[i], i);
		}
	}

	if(start > 65535) {
		fprintf(stderr, "Out of bounds.\n");
		exit(1);
	}

	if(rom_name[0]) {
		readrom(rom_name, start);
		if(bdos) {
			bdos_load();
		}
	} else if(fd_name[0][0]) {
		bootload(0);
	} else {
		fprintf(stderr, "Nothing to load from...\n");
		exit(1);
	}

	setterm(term);
	quit_signal = mainloop(start, speed);
	resetterm();

	for(i = 0; i < 4; i++) {
		if(fd_name[i][0]) {
			writedisk(fd_name[i], i);
		}
	}

	for(i = 0; i < 2; i++) {
		if(hd_name[i][0]) {
			writehd(hd_name[i], i);
		}
	}

	if(quit_signal != HALTED) {
		cleanexit(quit_signal);
	}
	cleanexit(0);
	return 1;
}

